import java.awt.*;

public class HStatusPanel extends Canvas implements Runnable
{

private Graphics offg;
private Image offimg;
private int time;
private Thread runner;
private Resource res = new Resource();
private int xpos = 0;
private boolean first = false;
private int vcorr = 0;
private int w = 103;
private int h = 10;
private Color col = new Color(160,160,255);
private boolean notify = false;
private HostChooser who = null;

public HStatusPanel(int time)
{
 this(null, time);
}

public HStatusPanel(HostChooser who,int time)
{
 this.who = who;
 this.time = time;
 if(who != null) {notify = true;}
 setSize(110,10+vcorr);
 setBackground(Color.lightGray);
 setVisible(true);
 repaint();
 runner = new Thread(this);
 runner.start();
}

public void run()
{
 for(int i=0; i<100; i++)
 {
  xpos++;
  repaint();
  res.pause(time/100);
 }
 xpos = 0;
 repaint();
 if(notify) {who.notifyTimeout();}
}

private void createBuffer()
{
 offimg = createImage(getSize().width, getSize().height);
 offg = offimg.getGraphics();
}

public void paint(Graphics g)
{
 //if(first) {createBuffer(); first=false;}
 offimg = createImage(getSize().width, getSize().height);
 offg = offimg.getGraphics();
 offg.setColor(Color.lightGray);
 offg.fillRect(0,0,w,h);
 offg.setColor(Color.black);
 offg.drawRect(0,0,w-1,h-1);
 offg.setColor(col);
 offg.fillRect(1,1,1+xpos,h-2);

 g.drawImage(offimg,0,vcorr,this);
}

public void update(Graphics g)
{
 paint(g);
}

}