import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

/*
export CLASSPATH=.
Usage: java JCon

You need a java1.1 runtime-environment or developement kit.
Until now, tested only on linux.
*/

public class JCon extends Frame implements WindowListener, Runnable
{

// needed by almost all classes
 public static TextArea info = new TextArea();
 public static TextField host = new TextField("10.0.0.1", 30);

// main-action in menu
 private JConMenuBar menu = new JConMenuBar();
 private Panel hostPanel = new Panel();
 public static StatusPanel statusPanel = new StatusPanel();

// final-variables
// private final Label hostLabel = new Label("Host:");
 private final HImagePanel hostLabel = new HImagePanel("images/host.gif");
// private final Label statusLabel = new Label("Status:");
 private final HImagePanel statusLabel = new HImagePanel("images/status.gif");
 private final String title = "JCon";
 private final Font f = new Font("monospaced", Font.PLAIN, 12);
 private Thread runner;

public JCon()
{
 setSize(650,350);
 setLocation(60,60);
 setTitle(title);
 setLayout(new BorderLayout());
 setBackground(Color.lightGray);
 
 hostPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
 hostPanel.add(hostLabel);
 hostPanel.add(host);
 hostPanel.add(statusLabel);
 hostPanel.add(statusPanel);

 add("North", hostPanel);
 add("Center", info);

 setMenuBar(menu);

// JIT not necessary yet
// System.out.println("Starting just-in-time-compiler...");
// Compiler.enable();
// Compiler.compileClasses("JCon.class");

 addWindowListener(this);

Image icon = HImage.getImage(this,"images/icon.gif");
setIconImage(icon);

validate();
host.setFont(f);
info.setFont(f);
setFont(f);
setVisible(true);

HostChooser hc = new HostChooser();

runner = new Thread(this);
runner.start();
}

public void run() {}

public static String getHost()
{
 return host.getText();
}

public void windowClosing(WindowEvent e) {System.exit(0);}
public void windowClosed(WindowEvent e) {}
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}


public static void main(String argv[])
{
 JCon jcon = new JCon();
}

public static void status(String msg)
{
 statusPanel.setText(msg);
}

public void debugWrite(String msg)
{
// System.out.println(msg);
}

public Insets getInsets() 
{ 
Insets in = super.getInsets();
return new Insets(in.top+5,in.left+5,in.bottom+5,in.right+5); 
}

}
