import java.awt.event.*;
import java.io.*;
import java.lang.reflect.*;

public class PortScanExecutor implements Runnable, ActionListener
{
private int cnt = 0;
private int port = 25;
private int delay = 100;
private String file = "";
private RandomAccessFile rd;
private boolean again = true;
private Thread runner;
private PortChooser pc;
private boolean delayChosen = false;


public PortScanExecutor(String file)
{
 this.file = file;
 pc = new PortChooser(this);

 runner = new Thread(this);
 runner.start();
}

public void run()
{
 while(!delayChosen) {Resource.pause(200);}

 try
 {
  rd = new RandomAccessFile(file,"r"); 
 }
 catch(Exception ex) {System.out.println(ex);}

 while(again)
 {
  cnt++;
  try
  {
   String str = rd.readLine();
   if(str == null) {again=false; break;}
   if(Resource.removeSpaces) {str = Resource.cut(str, " ");}
   JCon.status(str + " #"+cnt);   

   PortScanner ps = new PortScanner(str, port);
   Resource.pause(delay);
  }
  catch(Exception ex) {System.out.println(ex);}
 }
  JCon.status("Finished, " + (cnt-1) + " scanned.");
  Resource.pause(2000);
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == pc.okDelay)
 {
  pc.okDelay.removeActionListener(this);
  try
  {
   delay = Integer.parseInt(pc.getDelay());
   port = Integer.parseInt(pc.getPort());
   pc.dispose();
   delayChosen = true;
  }
  catch(Exception ex)
  {
   JCon.status("Cancelled!");
   pc.dispose();
   runner.destroy();
  }
 }
}

}
