//prototypes
int processWavfile(int,char**);
int processSunAudioFile(int,char**);

//set sun-aduio-options
int processSunAudioFile(int argc, char **argv)
{
 SunAudioFile *aufile = new SunAudioFile(&argv[1][0]);

for(int i=0;i<argc;i++)
{
 if(str_compare(&argv[i][0],"-q") == 1) {aufile->msg = 0;}
}

 if(aufile->msg) printf("Playing Sun-Audio-File...\n");
 aufile->play();
}


//set wavfile-options
int processWavfile(int argc, char **argv)
{
 WavFileTest *wavtest = new WavFileTest(&argv[1][0]);
 Wav8File *wav8file;
 Wav16File *wav16file;
 int bit_set = 0;

for(int i=0;i<argc;i++)
{
 if(str_compare(&argv[i][0],"8bit") == 1) {bit_set = 8;}
 if(str_compare(&argv[i][0],"16bit") == 1) {bit_set = 16;}
}

if(bit_set == 0)
{
 if(wavtest->bits == 8) {bit_set = 8; wav8file = new Wav8File(&argv[1][0]);}
 else if(wavtest->bits == 16) {bit_set = 16; wav16file = new Wav16File(&argv[1][0]);}
}
else if(bit_set == 8) wav8file = new Wav8File(&argv[1][0]);
else if(bit_set == 16) wav16file = new Wav16File(&argv[1][0]);
else {printf("File Error!\n"); exit(1);}

for(int i=0;i<argc;i++)
{
if(bit_set == 8)
{
 if(str_compare(&argv[i][0],"stereo") == 1) {wav8file->stereo = 1;}
 if(str_compare(&argv[i][0],"mono") == 1) {wav8file->stereo = 0;}
 if(str_compare(&argv[i][0],"-s") == 1) {wav8file->skip = 1;}
 if(str_compare(&argv[i][0],"8000") == 1) {wav8file->speed = 8000;}
 if(str_compare(&argv[i][0],"11025") == 1) {wav8file->speed = 11025;}
 if(str_compare(&argv[i][0],"22050") == 1) {wav8file->speed = 22050;}
 if(str_compare(&argv[i][0],"44100") == 1) {wav8file->speed = 44100;}
 if(str_compare(&argv[i][0],"48000") == 1) {wav8file->speed = 48000;}
 if(str_compare(&argv[i][0],"-q") == 1) {wav8file->msg = 0;}
}
else if(bit_set == 16)
{
 if(str_compare(&argv[i][0],"stereo") == 1) {wav16file->stereo = 1;}
 if(str_compare(&argv[i][0],"mono") == 1) {wav16file->stereo = 0;}
 if(str_compare(&argv[i][0],"-s") == 1) {wav16file->skip = 1;}
 if(str_compare(&argv[i][0],"8000") == 1) {wav16file->speed = 8000;}
 if(str_compare(&argv[i][0],"11025") == 1) {wav16file->speed = 11025;}
 if(str_compare(&argv[i][0],"22050") == 1) {wav16file->speed = 22050;}
 if(str_compare(&argv[i][0],"44100") == 1) {wav16file->speed = 44100;}
 if(str_compare(&argv[i][0],"48000") == 1) {wav16file->speed = 48000;}
 if(str_compare(&argv[i][0],"-q") == 1) {wav16file->msg = 0;}
}
}

if(bit_set == 8)
{
 if(wav8file->msg) printf("Playing Wav8-File...\n");

 wav8file->init();
 if(wav8file->isCorrect() != -1) wav8file->play();
 else {printf("Audio-File seems to be corrupt! (Try to override with \"-s\")");}
}
else if(bit_set == 16)
{
 if(wav16file->msg) printf("Playing Wav16-File...\n");

 wav16file->init();
 if(wav16file->isCorrect() != -1) wav16file->play();
 else {printf("Audio-File seems to be corrupt! (Try to override with \"-s\")");}
}

}
