#include <stdio.h>
#include <sys/ioctl.h>

class SunAudioFile : public AudioFile
{
private:
int quit(void);
//loop-int
int i;

public:
// functions
int init(void);
int play(void);

SunAudioFile(char *name)
{
//init
 device = "/dev/audio";
 file = name;
 msg = 1;
 skip = 0;
 run = 1;
 bits = 8;
 stereo = 0;
 speed = 22050;
 audio_fd = -1;
 format = AFMT_U8;
}

// end class
};

// functions

int SunAudioFile::init() {return 0;}

int SunAudioFile::play()
{
 // open audio-device
 if((audio_fd = open(device,O_WRONLY)) == -1) {perror(device); exit(1);}

// play sound
if(run)
{
 FILE *wavfile = fopen(file,"r");
 if(wavfile == NULL) {printf("File not found!\n"); run=0; return 0;}
 fseek(wavfile,0,SEEK_END);
 int total = ftell(wavfile);
 fseek(wavfile,22,SEEK_SET);
if(msg) printf("Processing %d Bytes in %d Byte-Buffers with %dkhz, ",total,len,speed);
if(msg) if(stereo == 1) {printf("Stereo @ %d Bits...\n", bits);}
if(msg) if(stereo != 1) {printf("Mono @ %d Bits...\n", bits);}

while(total > 0)
{
 for(int i=0;i<len;i++) {data[i] = 128;}
 fread(&data,len,1,wavfile);
 write(audio_fd,data,len);
 total -= len;
}

 fclose(wavfile);
}

quit();

return 0;
}

int SunAudioFile::quit()
{
 ioctl(audio_fd,SNDCTL_DSP_SYNC);
}

