#include <stdio.h>
#include <sys/ioctl.h>

class Wav16File : public AudioFile
{
private:
int quit(void);
//loop-int
int i;

public:
// functions
int init(void);
int play(void);
int isCorrect(void);
int scan_file(char *);

Wav16File(char *name)
{
//init
 device = "/dev/dsp";
 file = name;
 msg = 1;
 skip = 0;
 run = 1;
 bits = 16;
 stereo = 1;
 speed = 44100;
 audio_fd = -1;
 format = AFMT_S16_LE;
}

// end class Wav16File
};

// functions

int Wav16File::init()
{
 // open audio-device
 if((audio_fd = open(device,O_WRONLY)) == -1) {perror(device); exit(1);}

 if((ioctl(audio_fd,SNDCTL_DSP_SETFMT,&format)) == -1) {perror("16bit-mode"); exit(1);}
 if(msg) {printf("Using: %d Bits\n",format);}

 // what type of wav?
 if(!skip) scan_file(file);
}

int Wav16File::play()
{
 if(isCorrect() == -1) {return -1;}

// enable stereo
if(ioctl(audio_fd,SNDCTL_DSP_STEREO,&stereo) == -1) {if(msg) {perror("Stereo");} return -1;}

// set sampling rate
if(ioctl(audio_fd,SNDCTL_DSP_SPEED,&speed) == -1) {if(msg) {perror("Sampling Rate");} return -1;}

// play sound
if(run)
{
 FILE *wavfile = fopen(file,"r");
 if(wavfile == NULL) {printf("File not found!\n"); run=0; return 0;}
 fseek(wavfile,0,SEEK_END);
 int total = ftell(wavfile);
 fseek(wavfile,22,SEEK_SET);
if(msg) printf("Processing %d Bytes in %d Byte-Buffers with %dkhz, ",total,len16,speed);
if(msg) if(stereo == 1) {printf("Stereo @ %d Bits...\n", bits);}
if(msg) if(stereo != 1) {printf("Mono @ %d Bits...\n", bits);}

while(total > 0)
{
 fread(&data16,2,len16/2,wavfile);
 unsigned char devbuf[len16];
 int p=0;
 for(int i=0;i<len16;i++) {devbuf[i] = 128;}

for(int i=0;i<len16/2;i+=1)
{
 devbuf[p++] = (unsigned char) (data16[i] & 0xff);
 devbuf[p++] = (unsigned char) ((data16[i] >> 8) & 0xff);
}

 write(audio_fd,&devbuf,len16);
 total -= len16;
}

 fclose(wavfile);
}

quit();

return 0;
}

int Wav16File::isCorrect()
{
 if(run == 1) {return 0;}
 else return -1;
}

int Wav16File::scan_file(char *name)
{
//scan input
 FILE *file = fopen(name,"r");
 int channels = 0;
 int rate = 0;
 int bitrate = 0;
 char fmt[5];
 char fmt2[9];
 char fake[6];
 char fake2[4];
 if(msg) printf("Reading options of file %s :\n",name);

//do something
 fread(&fmt,4,1,file);
 fread(&fake2,4,1,file);
 fread(&fmt2,8,1,file);
 fmt2[8] = 0;
 if(msg) {printf("Format: %s\n",fmt2);}

 fread(&fake,6,1,file);
 fread(&channels,2,1,file);
 fread(&rate,4,1,file);
 fread(&fake2,4,1,file);
 fread(&bitrate,2,1,file);
 fread(&bitrate,2,1,file);

 if(msg) printf("Detected %d Channels and ",channels);
 if(msg) printf("a %dkhz Sampling-Rate @ %d Bits!\n",rate,bitrate);

speed = rate;
if(channels == 2) {stereo = 1;}
else {stereo = 0;}

if(bitrate != 16)
{
 if("msg") printf("The Soundfile is *not* in 16bit Format and will not be played!\n");
 run = 0;
}

 fclose(file);
 return 0;
}

int Wav16File::quit()
{
 ioctl(audio_fd,SNDCTL_DSP_SYNC);
}

