#include "StdFuncs.h"

#include "AudioFile.cpp"
#include "Wav8File.cpp"
#include "Wav16File.cpp"
#include "SunAudioFile.cpp"
#include "WavFileTest.cpp"
#include "Player.cpp"

int draw_info(void);
int configure(char *);
int quit();
char* file_format(char*);

int i, args;
char **arg;
char *file;
int wavfile_present = 0;
int aufile_present = 0;

int main(int argc, char **argv)
{
//check args
 if(argc < 2)
 {
  draw_info();
  exit(1);
 }

 if(str_compare(&argv[1][0],"-h"))
 {
  draw_info();
  exit(0);
 }

//init file
file = &argv[1][0];
args = argc;
arg = argv;

for(i=0;i<args;i++)
{
 configure(&arg[i][0]);
}

char *format = file_format(file);
if(str_compare(format,"wav")) processWavfile(args,arg);
if(str_compare(format,"au")) processSunAudioFile(args,arg);
if(str_compare(format,"null") && !wavfile_present && !aufile_present)
{
 printf("File type not supported!\n");
 exit(1);
}

// -wav -s | -au option is given
if(wavfile_present) processWavfile(args,arg);
else if(aufile_present) processSunAudioFile(args,arg);

//just exit(0)
quit();
}

int draw_info()
{
 printf("Usage: playwav <wav|au file> [options]\n");
 printf("   -h   this message \n");
 printf("   \n");
 printf("General options: \n");
 printf("   -au | -wav [-s]   force playing as Sun-Audio | WAV without filecheck \n");
 printf("   \n");
 printf("Additional Sun-Audio-options: \n");
 printf("   -q   no messages (only fatal errors) \n");
 printf("   \n");
 printf("Additional WAV-options:   \n");
 printf("   -s   skip auto-detection \n");
 printf("   -q   no messages (only fatal errors) \n");
 printf("   8000 | 11025 | 22050 | 44100 | 48000   sampling rate\n");
 printf("   stereo | mono   enable/disable stereo\n");
 printf("   8bit | 16bit   force bitrate\n");
 printf("   note: -wav, sampling rate, bitrate and stereo require -s option!\n");
 printf("   \n");
 printf("   Made by Cyberdemon <alc@beer.com>\n");
}

int configure(char *opt)
{
 if(str_compare(opt,"-h") == 1) {draw_info();}
 if(str_compare(opt,"-au") == 1) {aufile_present = 1;}
 if(str_compare(opt,"-wav") == 1) {wavfile_present = 1;}
 return 0;
}

char* file_format(char *s1)
{
 int l = strlen(s1);
 char format[20];
 char *c = &format[0];
// printf("%s\n",s1);

 for(int cnt=0;cnt<4;cnt++)
 {
  *c = s1[l-4+cnt];
  //printf("%c",s1[l-4+cnt]);
  c++;
 }
 *c = 0;
 c = &format[0];

// printf("Found %s\n",c);

 if(str_compare(c,".wav")) return "wav";
 else
 {
  for(int cnt=0;cnt<3;cnt++)
  {
   *c = s1[l-3+cnt];
   c++;
  }
  *c = 0;
  c = &format[0];

//  printf("Found %s\n",c);
  if(str_compare(c,".au")) return "au";
 }

 return "null";
}

int quit()
{
 exit(0);
}

