import java.awt.*;
import java.io.*;
import java.awt.event.*;

public class JConMenuBar extends MenuBar implements ActionListener
{

public static int delay = 500;

private Menu session = new Menu("Session");
private Menu scans = new Menu("Scans");
private Menu utils = new Menu("Utilities"); 
private Menu opts = new Menu("Options"); 
private Menu external = new Menu("External");
private Menu listscans = new Menu("Listscans");
private Menu info = new Menu("Info");

private MenuItem save = new MenuItem("Quicksave", new MenuShortcut(KeyEvent.VK_S));
private MenuItem load = new MenuItem("Load", new MenuShortcut(KeyEvent.VK_L));
private MenuItem saveAs = new MenuItem("Save", new MenuShortcut(KeyEvent.VK_A));
private MenuItem scan = new MenuItem("Full Scan", new MenuShortcut(KeyEvent.VK_F));
private MenuItem quit = new MenuItem("Exit", new MenuShortcut(KeyEvent.VK_Q));

private MenuItem ftp = new MenuItem("FTP/SYST");
private MenuItem ftpg = new MenuItem("GUEST(VIA FTP)");
private MenuItem pscan = new MenuItem("Port-scan");
private MenuItem webscan = new MenuItem("Webscan");
private MenuItem mailscan = new MenuItem("Mailer");
private MenuItem finger = new MenuItem("Finger"); 

private MenuItem connect = new MenuItem("JConnect", new MenuShortcut(KeyEvent.VK_J));

private MenuItem clear = new MenuItem("Clear", new MenuShortcut(KeyEvent.VK_X));
private MenuItem cut = new MenuItem("Cut before \":\"");

private MenuItem extlist = new MenuItem("Programs");

private MenuItem ftpl = new MenuItem("FTP/SYST+ANON");
private MenuItem ftp_guestl = new MenuItem("GUEST(VIA FTP)");
private MenuItem brute = new MenuItem("BruteForce");
private MenuItem maill = new MenuItem("Mailer");
private MenuItem portl = new MenuItem("PortScan");
private MenuItem webl = new MenuItem("WebScan");
private MenuItem progl = new MenuItem("Extern Prog");

private MenuItem readme = new MenuItem("Readme");
private MenuItem exploits = new MenuItem("Exploits");

public JConMenuBar()
{
session.add(save);
save.addActionListener(this);

session.add(saveAs);
saveAs.addActionListener(this);

session.add(load);
load.addActionListener(this);

session.add(scan);
scan.addActionListener(this);

session.add(quit);
quit.addActionListener(this);

scans.add(pscan);
scans.add(finger);
scans.add(ftp);
scans.add(ftpg);
scans.add(mailscan);
scans.add(webscan);
webscan.addActionListener(this);
finger.addActionListener(this);
ftp.addActionListener(this);
ftpg.addActionListener(this);
mailscan.addActionListener(this);
pscan.addActionListener(this);

utils.add(connect); 
connect.addActionListener(this);

opts.add(clear); 
clear.addActionListener(this);
opts.add(cut);
cut.addActionListener(this);

external.add(extlist);
extlist.addActionListener(this);

listscans.add(ftpl);
listscans.add(ftp_guestl);
listscans.add(brute);
brute.addActionListener(this);
ftpl.addActionListener(this);
ftp_guestl.addActionListener(this);
listscans.add(portl);
portl.addActionListener(this);
listscans.add(maill);
maill.addActionListener(this);
listscans.add(webl);
webl.addActionListener(this);
listscans.add(progl);
progl.addActionListener(this);

info.add(readme);
readme.addActionListener(this);
info.add(exploits);
exploits.addActionListener(this);

add(session);
add(scans);
add(utils);
add(opts);
add(external);
add(listscans);
add(info);

setFont(new Font("monospaced", Font.PLAIN, 12));

}

public void actionPerformed(ActionEvent e)
{

if(e.getSource() == scan) {scanAll();}
if(e.getSource() == quit) {System.exit(0);} 

if(e.getSource() == finger) { Finger finger = new Finger(JCon.host.getText(), true); }
if(e.getSource() == webscan) {WebScanner ws = new WebScanner(JCon.host.getText(), true);}
if(e.getSource() == ftp) {AccountScanner ftps = new AccountScanner(JCon.getHost(), true);}
if(e.getSource() == ftpg) {AccountScanner ftps = new AccountScanner(JCon.getHost(), true,"guest","guest");}
if(e.getSource() == mailscan) {MailScanner mails = new MailScanner(JCon.getHost(), true);}

if(e.getSource() == pscan) {Scanner scanner = new Scanner(JCon.getHost());} 
if(e.getSource() == connect) {JNet jnet = new JNet(JCon.getHost());}  
if(e.getSource() == save) {saveFile("scanned/" + JCon.host.getText() + ".txt");}
if(e.getSource() == load) {loadFile();}
if(e.getSource() == saveAs) {nameFile();}

if(e.getSource() == clear) {JCon.info.setText("");}

if(e.getSource() == cut)
{
 try
 {
  PrintStream out = new PrintStream(new FileOutputStream(".tmp"));
  out.print(JCon.info.getText());
 }
 catch (IOException ex) {JCon.status("Can't save temporary file!");}

 JCon.info.setText("");

 try
 {
  RandomAccessFile rd = new RandomAccessFile(".tmp","r");

 while(true)
 {
  String str = rd.readLine();
  if(str == null) {break;}
  str = Resource.cut(str,":");
  JCon.info.append(str+"\n");
 }
 rd.close();
 }
 catch(Exception ex) {System.out.println(ex+"@JConMenuBar.actionPerformed()");}
}

if(e.getSource() == extlist) {ExternList extl = new ExternList();}

if(e.getSource() == ftpl) {ftpListScan();}
if(e.getSource() == ftp_guestl) {ftpGuestListScan();}
if(e.getSource() == portl) {portListScan();}
if(e.getSource() == brute) {bruteScan();}
if(e.getSource() == maill) {mailListScan();}
if(e.getSource() == webl) {webListScan();}
if(e.getSource() == progl) {progListScan();}

if(e.getSource() == readme) {Displayer d = new Displayer("doc/readme");}
if(e.getSource() == exploits) {Displayer d = new Displayer("doc/hacks");}
}

public void bruteScan()
{
  JCon.status("Executing...");
  Resource res = new Resource();
  if(res.test(JCon.host.getText(), 21))
  {
   AccountExecutor ace = new AccountExecutor(JCon.host.getText());
  }
  else { JCon.status("No FTP - no BruteForce!"); }
}

public void mailListScan()
{
 String file = getFile();
 if(file != null) {ListExecutor mailexec = new ListExecutor(file, "MAIL");}
}

public void ftpListScan()
{
 String file = getFile();
 if(file != null) {ListExecutor ftpexec = new ListExecutor(file, "FTP");}
}

public void ftpGuestListScan()
{
 String file = getFile();
 if(file != null) {ListExecutor ftpexec = new ListExecutor(file, "FTP_GUEST");}
}

public void progListScan()
{
 String file = getFile();
 if(file != null) {ListExecutor progexec = new ListExecutor(file, "PROG");}
}

public void webListScan()
{
 String file = getFile();
 if(file != null) {ListExecutor webexec = new ListExecutor(file, "WEB");}
}

public void portListScan()
{
 String file = getFile();
 if(file != null) {PortScanExecutor pexec = new PortScanExecutor(file);}
}

public void nameFile() 
{
String file;

FileDialog fd = new FileDialog(new Frame(), "Save As...", FileDialog.SAVE);
fd.setVisible(true);
if(fd.getFile() != null) 
{
 file = fd.getDirectory() + fd.getFile();
 saveFile(file); 
}
}

private void loadFile()
{
String file = "";
String dir = "";

FileDialog fd = new FileDialog(new Frame(), "Load...", FileDialog.LOAD);
fd.setVisible(true);
if(fd.getFile() != null) 
{
 file = fd.getFile();
 dir = fd.getDirectory();
}

try 
{
 String data = "";
 String now = "";
 DataInput in = new DataInputStream(new FileInputStream(dir + file));

 try {while( (data = in.readLine()) != null) 
 {
  now = now + data + "\n";}
 }
 catch (IOException e) {JCon.status(e.toString());}

 JCon.info.setText(now);

 if(file.endsWith(".txt")) 
 {
  StringBuffer sb = new StringBuffer(file);
  sb.setLength(sb.length()-4);
  JCon.host.setText(sb.toString());
 }
 
}
catch (FileNotFoundException e) {JCon.status("Error while loading!");}
}


private void saveFile(String file)
{
 String data = JCon.info.getText();
 try
 {
  PrintStream out = new PrintStream(new FileOutputStream(file));
  out.print(data);
  out.flush();
  out.close();
  JCon.status("Saved.");
 }
 catch (IOException e) {JCon.status("Can't save!");}
}

public void scanAll() 
{
 String host = JCon.host.getText();
 Scanner scanner = new Scanner(host, true);
 pause(delay);
 Finger finger = new Finger(host, true);
 pause(delay);
 MailScanner mails = new MailScanner(host, true);
 pause(delay);
 WebScanner webs = new WebScanner(host,true);
 pause(delay);
 AccountScanner ftps = new AccountScanner(host, true);
 pause(delay);
 AccountScanner ftpgs = new AccountScanner(host, true,"guest","guest");
 pause(delay);
 ExternList.visible = false;
 ExternList elist = new ExternList();
 elist.runAll();
 ExternList.visible = true;
}

private String getFile()
{
String file;

FileDialog fd = new FileDialog(new Frame(), "Open List...", FileDialog.LOAD);
fd.setVisible(true);
if(fd.getFile() != null)
{
 file = fd.getDirectory() + fd.getFile();
 return file;
}
else {return null;}
}

private void pause(int time)
{
try {Thread.sleep(time);}
catch(Exception ex) {System.out.println(ex);}
}

}

